require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_STRING_H)) {
    die("Never use <bits/string3.h> directly; include <string.h> instead.");
}
undef(&memcpy) if defined(&memcpy);
undef(&memmove) if defined(&memmove);
undef(&memset) if defined(&memset);
undef(&strcat) if defined(&strcat);
undef(&strcpy) if defined(&strcpy);
undef(&strncat) if defined(&strncat);
undef(&strncpy) if defined(&strncpy);
if(defined(&__USE_GNU)) {
    undef(&mempcpy) if defined(&mempcpy);
    undef(&stpcpy) if defined(&stpcpy);
}
if(defined(&__USE_BSD)) {
    undef(&bcopy) if defined(&bcopy);
    undef(&bzero) if defined(&bzero);
}
unless(defined(&memcpy)) {
    sub memcpy {
	local($dest, $src, $len) = @_;
	eval q((( &__bos0 ($dest) != ( &size_t) -1) ?  &__builtin___memcpy_chk ($dest, $src, $len,  &__bos0 ($dest)) :  &__memcpy_ichk ($dest, $src, $len)));
    }
}
unless(defined(&memmove)) {
    sub memmove {
	local($dest, $src, $len) = @_;
	eval q((( &__bos0 ($dest) != ( &size_t) -1) ?  &__builtin___memmove_chk ($dest, $src, $len,  &__bos0 ($dest)) :  &__memmove_ichk ($dest, $src, $len)));
    }
}
if(defined(&__USE_GNU)) {
    eval 'sub mempcpy {
        local($dest, $src, $len) = @_;
	    eval q((( &__bos0 ($dest) != ( &size_t) -1) ?  &__builtin___mempcpy_chk ($dest, $src, $len,  &__bos0 ($dest)) :  &__mempcpy_ichk ($dest, $src, $len)));
    }' unless defined(&mempcpy);
}
unless(defined(&memset)) {
    sub memset {
	local($dest, $ch, $len) = @_;
	eval q((( &__bos0 ($dest) != ( &size_t) -1) ?  &__builtin___memset_chk ($dest, $ch, $len,  &__bos0 ($dest)) :  &__memset_ichk ($dest, $ch, $len)));
    }
}
if(defined(&__USE_BSD)) {
    eval 'sub bcopy {
        local($src, $dest, $len) = @_;
	    eval q(( (( &__bos0 ($dest) != ( &size_t) -1) ?  &__builtin___memmove_chk ($dest, $src, $len,  &__bos0 ($dest)) :  &__memmove_ichk ($dest, $src, $len))));
    }' unless defined(&bcopy);
    eval 'sub bzero {
        local($dest, $len) = @_;
	    eval q(( (( &__bos0 ($dest) != ( &size_t) -1) ?  &__builtin___memset_chk ($dest, ord(\'\\\\0\', len, __bos0 (dest))		   : __memset_ichk (dest, \'\\\\0\'), $len))));
    }' unless defined(&bzero);
}
unless(defined(&strcpy)) {
    sub strcpy {
	local($dest, $src) = @_;
	eval q((( &__bos ($dest) != ( &size_t) -1) ?  &__builtin___strcpy_chk ($dest, $src,  &__bos ($dest)) :  &__strcpy_ichk ($dest, $src)));
    }
}
if(defined(&__USE_GNU)) {
    eval 'sub stpcpy {
        local($dest, $src) = @_;
	    eval q((( &__bos ($dest) != ( &size_t) -1) ?  &__builtin___stpcpy_chk ($dest, $src,  &__bos ($dest)) :  &__stpcpy_ichk ($dest, $src)));
    }' unless defined(&stpcpy);
}
unless(defined(&strncpy)) {
    sub strncpy {
	local($dest, $src, $len) = @_;
	eval q((( &__bos ($dest) != ( &size_t) -1) ?  &__builtin___strncpy_chk ($dest, $src, $len,  &__bos ($dest)) :  &__strncpy_ichk ($dest, $src, $len)));
    }
}
unless(defined(&strcat)) {
    sub strcat {
	local($dest, $src) = @_;
	eval q((( &__bos ($dest) != ( &size_t) -1) ?  &__builtin___strcat_chk ($dest, $src,  &__bos ($dest)) :  &__strcat_ichk ($dest, $src)));
    }
}
unless(defined(&strncat)) {
    sub strncat {
	local($dest, $src, $len) = @_;
	eval q((( &__bos ($dest) != ( &size_t) -1) ?  &__builtin___strncat_chk ($dest, $src, $len,  &__bos ($dest)) :  &__strncat_ichk ($dest, $src, $len)));
    }
}
1;
